#include <stdio.h>

#include "playout.h"
#include "rating.h"
#include "uct.h"


/*------------------------------------------------------------------*/
/* プレイアウト                                                     */
/*------------------------------------------------------------------*/
int
PlayOut( struct game *game, int starting_color, struct move_count *move_count, struct mt19937p *mt )
{
	int color = starting_color;
	int pos = -1;
	double score = 0;
	int result = 0;
	int length;
	int passes;

	length = MAX_MOVES-game->moves;
	if(length < 0) length = 0;

	passes = (game->record[game->moves-1].pos == PASS && game->moves > 1);

	while (length-- && passes < 2) {
		pos = RatingMove( game, color, mt );

		SetStone( game, color, pos );

		move_count[pos].colors[color]++;

		if (pos == PASS) passes++;
		else passes=0;

		color = OTHER_COLOR(color);
	}

	// 日本ルール対応？
	score = (double)BoardScore( game ) - komi[starting_color];

	if (score > 0) {		/* 黒の勝ち */
		result = (starting_color == S_BLACK ? 1 : 0);
	} else if(score < 0) {	/* 白の勝ち */
		result = (starting_color == S_WHITE ? 1 : 0);
	}

	return result;
}